Imports System.Data.SqlClient
Imports TransactionDemoDataAccess

Public Class ManualSalesComponent
    Implements ISalesComponent

    Public Function MakeSale(ByVal connectionString As String, ByVal customerID As String, ByVal productID As Integer, _
      ByVal requestedQty As Integer, ByVal unitPrice As Double, ByVal discount As Double) As Boolean Implements ISalesComponent.MakeSale

        Dim conn As New SqlClient.SqlConnection
        Dim successfulSale As Boolean
        Dim dataAccess As New DataAccess
        Dim trans As SqlTransaction

        Try

            conn.ConnectionString = connectionString
            conn.Open()

            ' return a transaction object from the opened connection
            trans = conn.BeginTransaction()

            successfulSale = DataAccess.newOrder(conn, trans, customerID, productID, requestedQty, unitPrice, discount)

            If successfulSale Then

                successfulSale = DataAccess.adjustInventory(conn, trans, requestedQty, productID)

                If successfulSale Then

                    ' check credit card limit. if over limit rollback transaction
                    successfulSale = DataAccess.checkCreditCard()

                End If

            End If

            If successfulSale Then

                ' All operations were successful, commit changes
                trans.Commit()

            Else

                trans.Rollback()
                successfulSale = False

            End If

        Catch ex As Exception

            ' If an error occurs, rollback transaction
            trans.Rollback()
            Throw ex

        Finally

            MakeSale = successfulSale
            trans.Dispose()

            If conn.State = ConnectionState.Open Then
                conn.Close()
            End If

        End Try

    End Function

End Class