Imports System.Web.Services
Imports System.EnterpriseServices
Imports TransactionDemoDataAccess

<System.Web.Services.WebService(Namespace:="http://tempuri.org/TransactionDemoWebService/Service1")> _
Public Class SalesComponentWeb
    Inherits System.Web.Services.WebService

#Region " Web Services Designer Generated Code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Web Services Designer.
        InitializeComponent()

        'Add your own initialization code after the InitializeComponent() call

    End Sub

    'Required by the Web Services Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Web Services Designer
    'It can be modified using the Web Services Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        'CODEGEN: This procedure is required by the Web Services Designer
        'Do not modify it using the code editor.
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

#End Region

    <WebMethod(TransactionOption:=TransactionOption.RequiresNew)> _
    Public Function MakeSale(ByVal connectionString As String, ByVal customerID As String, ByVal productID As Integer, _
      ByVal requestedQty As Integer, ByVal unitPrice As Double, ByVal discount As Double) As Boolean

        Dim conn As New SqlClient.SqlConnection
        Dim successfulSale As Boolean
        Dim dataAccess As New DataAccess

        Try

            conn.ConnectionString = connectionString
            conn.Open()

            ' attempt to add a new order. if this fails newOrder 
            ' method will return false and transaction will be rolled back
            successfulSale = dataAccess.newOrder(conn, customerID, productID, requestedQty, unitPrice, discount)

            If successfulSale Then

                ' attempt to adjust inventory, if this fails, adjustInventory 
                ' method will return false and transaction will be rolled back
                successfulSale = dataAccess.adjustInventory(conn, requestedQty, productID)

                If successfulSale Then

                    ' check credit card limit. if over limit rollback transaction
                    successfulSale = dataAccess.checkCreditCard()

                End If

            End If

            If successfulSale Then

                ' if the sale is successful, commit the transaction
                ContextUtil.SetComplete()

            Else

                ' if some part of the sale was unsuccessful (the credit card check), 
                ' rollback the transaction
                ContextUtil.SetAbort()
                successfulSale = False

            End If

        Catch ex As Exception

            ' If an error occurs, rollback transaction
            ContextUtil.SetAbort()
            Throw ex

        Finally

            MakeSale = successfulSale

        End Try

    End Function

End Class
